/****************************************************************************************
 * KF8A系列单片机	KF8A100GQT_DEMO	开发板演示程序
 * 标    题: 通用全双工异步串口实验
 * 项目名: 07- UART_Sample
 * 开发环境：ChipON IDE
 * 版          本     ：V1.0 (2019/07/23)
 * 作 者: 上海芯旺微电子有限公司
 * 功能简述: 将串口2接收到的数据,以0x0D,0x0A结尾，返回给PC
 * 硬件说明： UART2引脚为P43、P44，接到TTL-USB芯片，插入USB线与PC通信
 * 跳线接法： 单片机供电跳帽选择为3.3V或5V
 ****************************************************************************************/
#include<KF8A100GQT.h>
#include "includes.h"

unsigned char Rev_Flag,Rev_StopFlag;
unsigned char Rev_count;

void delay_ms(uint16 num)
{
	uint16 i,j;
	for(i=0;i<num;i++)
	{
		j=1000;
		while(j--);
	}
}

void SYS_Init(void)
{
	//使用外部晶振时，引脚配置输入，配置字选择外部时钟且允许切换
	SCLKCTL = SYSYCLK_SEL_SCKS|SYSCLK_SCLK_SEL_INTHF|SYSCLK_FREQ_DIV1;	//INTHF作为主时钟
	_NOP();_NOP();	//高速时钟稳定
	PLLEN=0;
	PLLCTL = PLL_SEL_DIV1|PLL_SEL_INTHF|PLLBIAS_CUR_MIN|PLLPMUL_2;
	PLLEN=1;
	delay_ms(200);
	SCLKCTL|=SYSYCLK_SEL_SCKS|SYSCLK_SCLK_SEL_UPCK;		//UPCK作为主时钟	32M
	SCLKOE = 0;		//机器周期禁能输出,输出波形与IO翻转速率相关
	CLKOUTSEL = 0;
	HFCKCTL = 0xCE;	//外设时钟开启,选择INTHF为HFCLK时钟信号

	TR0 = 0;	TR1	= 0;	TR2	= 0;	TR3 = 0;
	TR4 = 0;	TR5 = 0;	TR6 = 0;	TR7 = 0;
	TR9 = 0;	TRA = 0;	TRB = 0;
	P0LR = 0;	P1LR = 0;	P2LR = 0;	P3LR = 0;
	P4LR = 0;	P5LR = 0;	P6LR = 0;	P7LR = 0;
	P9LR = 0;	PALR = 0;	PBLR = 0;
}

void main()
{
	unsigned char i;
	SYS_Init();
	UART2_Init();

	//总中断开启
	AIE=1;
	PUIE=1;

	while(1)
	{
		if(Rev_Flag == 1)
		{
			Rev_Flag=0;
			for(i=0;i<Rev_count;i++)
			{
				UART2_SendBuf(UART2_BUF[i]);
			}
			Rev_count=0;
		}
	}

}


//中断函数0:0X04入口地址
void int_fun0() __interrupt (0)
{
	volatile uint8 revBuf; // 避免优化下未读取RXSDR2

	if(RC2IE && RC2IF)
	{
		if(FRER2)
		{
			revBuf=	RXSDR2; //读清零RC2IF,清零FRER2
		}
		else if(OVFER2)
		{
			CRXEN2=0;		// 清零OVFER2
			revBuf=	RXSDR2; //读清零RC2IF
			CRXEN2=1;		// 回到接收使能
		}
		else
		{
			UART2_BUF[Rev_count]=RXSDR2;  	//清零 RX2IF
			if(UART2_BUF[Rev_count] == 0x0D)
			{
				Rev_StopFlag=1;
			}
			else
			{
				if(Rev_StopFlag)
				{
					if(UART2_BUF[Rev_count] == 0x0A)
						Rev_Flag=1;
					else Rev_StopFlag=0;
				}
				else
				{
					Rev_StopFlag=0;
				}
			}
			Rev_count++;
		}
	}
}


//中断函数1:0x14入口地址
void int_fun1() __interrupt (1)
{

}
